# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# +000 MODEL
# +++1 SUITABILITY CRITERIA MAP
# ++++ 1.1. -SUITABILITY MAP WITHOUT WEIGHTS TO FACTORS
# ++++ 1.2. -SUITABILITY MAP WITH WEIGHTS TO FACTORS
# +++2 FINAL MAP COMBINING CONSTRAINTS AND SUITABLE CRITERIA
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# +++1 SUITABILITY CRITERIA MAP

# ++++ 1.1. -SUITABILITY MAP WITHOUT WEIGHTS TO FACTORS
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
system(sprintf("gdal_calc.py -A %s -B %s -C %s -D %s -E %s -F %s -G %s -H %s -I %s -J %s --co=\"COMPRESS=LZW\" --outfile=%s --calc=\"%s\" --overwrite",
               score_preci_factmult,
               score_dist2water,
               score_slope,
               score_biomass_prod,
               score_dist2boundaries,
               score_dist2roads,
               score_mask_dist2electricity,
               score_mask_dist2towns,
               score_mask_dist2health,
               score_mask_dist2education,
               
               suitability_map_no_weight,
               
               "(A*0.1+B*0.1+C*0.1+D*0.1+E*0.1+F*0.1+G*0.1+H*0.1+I*0.1+J*0.1)"
))

system(sprintf("gdal_calc.py -A %s -B %s -C %s -D %s -E %s -F %s -G %s -H %s -I %s -J %s --co=\"COMPRESS=LZW\" --outfile=%s --calc=\"%s\" --overwrite",
               score_dist2water,
               score_slope,
               score_dist2roads,
               
               score_biomass_prod,
               score_dist2boundaries,
               score_preci_factmult,
               
               score_mask_dist2electricity,
               score_mask_dist2towns,
               score_mask_dist2health,
               score_mask_dist2education,
               
               suitability_map_weighted,
               
               "((A*0.5/3+B*0.5/3+C*0.5/3)+
                (D*0.3/3+E*0.3/3+F*0.3/3)+
                (G*0.2/4+H*0.2/4+I*0.2/4+J*0.2/4))"
))
system(sprintf("gdal_calc.py -A %s -B %s --co=\"COMPRESS=LZW\" --outfile=%s --calc=\"%s\" --overwrite",
               suitability_map_weighted,
               tmp_mask_constraints_combi,
               suitab_constraints_map,
               "A*(1-B)"
))

## REMOVE "tmp_" FILES
system(sprintf("rm -r -f %s",
               paste0(data0dir,"tmp*.tif")
))

